﻿; Этот пример демонстрирует работу нескольких функции из библиотеки HID_Lib_Plus.
; После его запуска, на экране появятся данные о конфигурации демонстрационного устройства.

#USB_PID  = $F4EF      ; Идентификаторы демонстрационного устройства.
#USB_VID  = $AB80

 CompilerIf Defined(HIDP_CAPS, #PB_Structure)=0 ; Если структура ранее не была объявлена
  Structure HIDP_CAPS                           ; объявляем её.
    Usage.w
    UsagePage.w
    InputReportByteLength.w
    OutputReportByteLength.w
    FeatureReportByteLength.w
    Reserved.w[17]
    NumberLinkCollectionNodes.w
    NumberInputButtonCaps.w
    NumberInputValueCaps.w
    NumberInputDataIndices.w
    NumberOutputButtonCaps.w
    NumberOutputValueCaps.w
    NumberOutputDataIndices.w
    NumberFeatureButtonCaps.w
    NumberFeatureValueCaps.w
    NumberFeatureDataIndices.w
  EndStructure
 CompilerEndIf

If OpenLibrary(1,"HID_Lib_Plus_Unicode_x64.dll")=0
 MessageRequester("", "Отсутствует файл "+Chr(34)+"HID_Lib_Plus_Unicode_x64.dll"+Chr(34), 16)
 End
EndIf

Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_CloseDevice(Handle)
 HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")
Prototype HID_GetCaps(Handle, *Pointer)
 HID_GetCaps.HID_GetCaps=GetFunction(1,"HID_GetCaps")
Prototype HID_GetManufacturer(Handle)
 HID_GetManufacturerString.HID_GetManufacturer=GetFunction(1,"HID_GetManufacturerString")
Prototype HID_GetProduct(Handle)
 HID_GetProductString.HID_GetProduct=GetFunction(1,"HID_GetProductString")
Prototype HID_GetSerialNumber(Handle)
 HID_GetSerialNumberString.HID_GetSerialNumber=GetFunction(1,"HID_GetSerialNumberString")
 
Handle=HID_OpenDevice(#USB_PID, #USB_VID, -1, 0) ; Установка связи с демонстрационным устройством.

 If Handle
   String.s="Изготовитель     -  "+PeekS(HID_GetManufacturerString(Handle))+Chr(10)
   String  +"Продукт              -  "+PeekS(HID_GetProductString(Handle))+Chr(10)
   String  +"Серийный номер -  "+PeekS(HID_GetSerialNumberString(Handle))+Chr(10)+Chr(10)
   
   HID_GetCaps(Handle, @Info.HIDP_CAPS)
   
   String  +"Размер INPUT репорта     -  "+Str(Info\InputReportByteLength)+Chr(10)
   String  +"Размер OUTPUT репорта  -  "+Str(Info\OutputReportByteLength)+Chr(10)
   String  +"Размер FEATURE репорта -  "+Str(Info\FeatureReportByteLength)
   
   HID_CloseDevice(Handle)
   
   MessageRequester("Информация о Demo_Device", String, 64)
 Else
   MessageRequester("PID  - F4EFH;  VID  - AB80H", "Нет связи с демонстрационным устройством!", 48)
 EndIf
; IDE Options = PureBasic 4.40 (Windows - x64)
; CursorPosition = 28
; FirstLine = 15
; EnableUnicode
; EnableXP
; UseIcon = .ico
; Executable = Demo_Device_Info_Unicode.exe