﻿#USB_PID=$F4EF  ; USB идентификаторы устройства
#USB_VID=$AB80

Enumeration
  #Window_0
  #Text_0
  #Text_1
  #Button_0
  #Button_1
EndEnumeration

Global R_Handle, W_Handle ; Глобальные переменные

If OpenLibrary(1,"HID_Lib_Plus_Unicode.dll")=0 ; Загрузка библиотеки
 MessageRequester("", "Отсутствует файл "+Chr(34)+"HID_Lib_Plus_Unicode.dll"+Chr(34), 16)
 End  ; Завершение работы программы
EndIf
; Объявление функций из библиотеки HID_Lib_Plus
Prototype HID_DeviceTest(PID.w, VID.w, Number.w, Index.w)
 Global HID_DeviceTest.HID_DeviceTest=GetFunction(1,"HID_DeviceTest")
Prototype HID_OpenDevice(PID.w, VID.w, Number.w, Index.w)
 Global HID_OpenDevice.HID_OpenDevice=GetFunction(1,"HID_OpenDevice")
Prototype HID_ReadDevice(Handle, *Buffer, LenBuf)
 Global HID_ReadDevice.HID_ReadDevice=GetFunction(1,"HID_ReadDevice")
Prototype HID_WriteDevice(Handle, *Buffer, LenBuf)
 Global HID_WriteDevice.HID_WriteDevice=GetFunction(1,"HID_WriteDevice")
Prototype HID_CloseDevice(Handle)
 Global HID_CloseDevice.HID_CloseDevice=GetFunction(1,"HID_CloseDevice")
; Проверка доступности устройства
Procedure FindDevice_Timer()
Static Old_Test
Test=HID_DeviceTest(#USB_PID, #USB_VID, 2, 0)
If Test<>Old_Test ; Устройство подключили или отключили
 Old_Test=Test 
 If Test          ; Устройство подключили
  HID_CloseDevice(R_Handle) : HID_CloseDevice(W_Handle)
  W_Handle=HID_OpenDevice(#USB_PID, #USB_VID, 2, 0)
  R_Handle=HID_OpenDevice(#USB_PID, #USB_VID, 2, 0)
  SetGadgetText(#Text_0, "Устройство подключено")
  SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, 0)
 Else             ; Устройство отключили
  HID_CloseDevice(R_Handle) : R_Handle=0
  HID_CloseDevice(W_Handle) : W_Handle=0
  SetGadgetText(#Text_0, "Устройство не найденно")
  SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, RGB(255, 0, 0))
  SetGadgetText(#Text_1, "Кнопка = 0")
 EndIf
EndIf
EndProcedure
; Приём данных от устройства. 
; Код процедуры выполняется в отдельном потоке.
Procedure ReadDavice_Thread(*p)
 Dim InBuffer.b(2)
 Repeat
  If R_Handle
   If HID_ReadDevice(R_Handle, @InBuffer(), 2)
     SetGadgetText(#Text_1, "Кнопка = "+Str(InBuffer(1)!1))
   EndIf
  EndIf
  Delay(10)
 ForEver
EndProcedure
; Передача данных устройству
Procedure SendDevice(Led.b)
 Dim OutBuffer.b(2)
 If W_Handle
   OutBuffer(1) = Led
   HID_WriteDevice(W_Handle, @OutBuffer(), 2)
 Else
  MessageRequester("Demo Device","Устройство не подключено к компьютеру!",16)
 EndIf
EndProcedure

Flag = #PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible
If OpenWindow(#Window_0, 0, 0, 258, 116, "USB Demo device", Flag)
 TextGadget(#Text_0, 5, 10, 250, 15, "Устройство не найденно", #PB_Text_Center)
   SetGadgetColor(#Text_0, #PB_Gadget_FrontColor, RGB(255, 0, 0))
 TextGadget(#Text_1, 150, 60, 95, 15, "Кнопка = 0", #PB_Text_Center)
 ButtonGadget(#Button_0, 5, 35, 120, 28, "Зажечь светодиод")
 ButtonGadget(#Button_1, 5, 75, 120, 28, "Погасить светодиод")
EndIf

FindDevice_Timer()
HideWindow(#Window_0, 0)
AddWindowTimer(#Window_0, 1, 400) ; Активация таймера.
CreateThread(@ReadDavice_Thread(), 0) ; Запуск процедуры в отдельном потоке.

Repeat
 Event=WaitWindowEvent()
 If Event=#PB_Event_Timer ; События от таймера
     If EventTimer()=1    ; Таймер с ID 1
       FindDevice_Timer() ; Проверка доступности устройства
     EndIf
 ElseIf Event=#PB_Event_Gadget ; События от гаджетов
   Gadget=EventGadget()
   If Gadget = #Button_0 Or Gadget = #Button_1 ; Клик по кнопкам
     SendDevice(Gadget - #Button_1)
   EndIf
 EndIf
Until Event=#PB_Event_CloseWindow ; Прерывание цикла при закрытии окна
; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 25
; FirstLine = 42
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; UseIcon = .ico
; Executable = Demo_Device.exe